/*
 * Copyright (c) 2016, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/**
 * @file   : ptty.jquery.min.js
 * @ver    : 0.0.5 (beta)
 * @author : Pachanka <social@pachanka.org>
 * @url    : http://goto.pachanka.org/ptty/docs
 * @desc   : Ptty (Pseudo teletype). A terminal emulator plugin for jQuery. 
 * @license: WTFPL Version 2. (http://www.wtfpl.net/)
 **/
!function(e){e.fn.Ptty=function(t){var n="0.0.5 beta",o=function(){return{ajax_options:{url:window.location.pathname,type:"POST"},param:"cmd",ps:"$",caret:"▮",caret_blink:800,native_css:!0,theme:"boring",native_cmds:!0,autocomplete:!0,history_max:800,autofocus:!0,before_cmd:!1,after_cmd:!1,i18n:{welcome:"Ptty ("+n+").<br> Type <b>help</b> to list the available commands.",error_not_found:"Command not found.",error_bad_method:"Invalid command method.",error_ajax:"Server error."}}},a={};return this.each(function(){var n=e(this),r={},l={},s={},d={},p=[],c={ps:null,"in":null,out:null,last:null,next:null,data:null},u=e.extend(!0,o(),t);a.get_terminal=function(e){return e?n.find(e):n},a.native_style=function(t,n){var o=t.attr("id");if(o=o?"#"+o:"."+t.attr("class").split(" ")[1],"boring"===n){var i=['.boring, .boring .prompt, .boring .content{ font-family: "Courier New", Courier, monospace; background-color: #111; color: #ddd; }',".boring .content{ padding: 15px 15px 0 15px; }",".boring .prompt{ padding: 0 15px 15px 15px; }",'.boring .loading span::after{content: "⚙"; color: #ddd; font-size: 10em; border-radius: 10em; opacity: 0.4;}',".boring .content ul{ margin: 0; }",".boring .prompt .input.show-caret{ color: #ddd; opacity: .85; }",".boring .prompt .input, .boring .prompt .input::before, .boring .prompt .input::after{ color: transparent; text-shadow:0 0 0 #ddd; }",".boring .content div .cmd_in .cmd_ps, .boring .prompt .input::before{ padding-right: 10px; }",".boring .content ul li{ list-style-type: none; }",".boring div.prompt div.input::after{ font-size: 2em; }",".boring div.prompt div.input, .boring div.content div div.cmd_in, .boring div.prompt div.input::before{ line-height: 2em; }"].join("\n");e('<style id="ptty-boring-theme">'+i+"</style>").appendTo("head")}var a=[o+"{ position: relative; display: block; overflow-X: hidden; height: 100%; }","div.content div p{ margin: 0; }","div.content div{ clear: both; white-space:pre-wrap; word-wrap:break-word; }","div.content div ul{ padding: 0; white-space: normal }","div.content div ul li{ list-style: none; }","div.content div ul.sq-li li{ display: inline-block; text-align: center; padding: 10px; min-width: 5%; }","div.prompt div.input{ width: 100%; white-space:pre-wrap; word-wrap:break-word; cursor: default; outline: none;}","div.prompt div.input::before{ vertical-align: middle; content: attr(data-ps); }","div.prompt div.input::after{ visibility : visible; vertical-align: middle; content: attr(data-caret); }","div.prompt div.input.blink::after{ visibility : hidden; }","div.prompt .hide{ position:absolute; top: -9999em; }","div.loading{ display: none; }","div.loading.working{ display: block; display:flex; justify-content: center; align-items: center;position: fixed;  width: inherit; height: inherit; }","div.loading span{ -webkit-animation: spin 4s linear infinite; -moz-animation: spin 4s linear infinite; -ms-animation: spin 4s linear infinite; -o-animation: spin 4s linear infinite; animation: spin 4s linear infinite; }"].join("\n "+o+" ");a+="@-moz-keyframes spin { 100% { -moz-transform: rotate(360deg); } }@-webkit-keyframes spin { 100% { -webkit-transform: rotate(360deg); } }@-ms-keyframes spin { 100% { -ms-transform: rotate(360deg); } }@-o-keyframes spin { 100% { -o-transform: rotate(360deg); } }@keyframes spin { 100% { transform: rotate(360deg); } }",e('<style id="ptty-styles">'+a+"</style>").appendTo("head")},a.native_commands=function(){a.register("command",{name:"clear",method:function(e){return e.last="",e.out="",e},options:[],help:"Cleans the screen leaving a new command prompt ready."}),a.register("callback",{name:"clear",method:function(e){return n.find(".content").html(""),e}}),a.register("command",{name:"history",method:function(e){if(e.hasOwnProperty("clear"))p=[],e.out="History cleared.";else if(p.length>0){var t;e.out="<ul>";for(t in p)e.out+="<li>"+p[t]+"</li>";e.out+="</ul>"}return e},options:["clear"],help:"Shows list of typed in commands. Type <i>history clear</i> to clear your history."}),a.register("command",{name:"help",method:function(e){if("string"==typeof e[1]&&e[1].length>0)if(e.hasOwnProperty("-a")||e.hasOwnProperty("--all")){e.out="<b>Available commands:</b></br></br><ul>";for(i in r)e.out+="<li><p><b>"+i+"</b> - ",e.out+=r[i].help+"</p></br></li>";e.out+="</ul>\n"}else"undefined"!=typeof r[e[1]]?(e.out="<b>"+e[1]+"</b> - ",""!==r[e[1]].help?e.out+=r[e[1]].help+"\n":e.out+="No help entry available.\n"):e.out='help: The "'+e[1]+'" option does not exist.\n';else{e.out='Use "help [comand name]" to display specific info about a command.</br>\n',e.out+='Available commands are:</br><ul class="sq-li">';for(i in r)e.out+="<li>"+i+"</li>";e.out+="</ul>\n"}return e},options:[1,"-a","--all"],help:"Displays a list of useful information. Usage: <i>help command-name</i> to show <i>command-name</i>'s help.<i>help -a</i> or <i>help --all</i> to display all help."})},a.native_responses=function(e){for(var t in e)e.hasOwnProperty(t)&&a.register("response",{name:t,method:function(n){return e[t]=n[t],n}})},a.run_command=function(e,t){quiet=t,w(e)},a.echo=function(e,t){e&&n.find(".content").append('<div><div class="cmd_out">'+e+"</div></div>"),t||j()},a.change_settings=function(t){e.extend(!0,u,t)},a.unregister=function(e,t){var n=!1;return"object"==typeof t&&t.hasOwnProperty("name")&&(t=t.name),"callbefore"==e&&d.hasOwnProperty(t)?(n=!0,delete d[t]):"command"==e&&r.hasOwnProperty(t)?(n=!0,delete r[t]):"response"==e&&l.hasOwnProperty(t)?(n=!0,delete l[t]):"callback"==e&&s.hasOwnProperty(t)&&(n=!0,delete s[t]),n},a.register=function(e,t){var n=!1;return t&&(method_name=t.hasOwnProperty("name")?t.name:!1,method_exe=t.hasOwnProperty("method")?t.method:!1,method_options=t.hasOwnProperty("options")?t.options:[],method_help=t.hasOwnProperty("help")?t.help:"","callbefore"==e&&"function"==typeof method_exe?(d[method_name]=method_exe,n=!0):"command"!=e||"string"!=typeof method_exe&&"function"!=typeof method_exe?"response"==e&&"function"==typeof method_exe?(l[method_name]=method_exe,n=!0):"callback"==e&&"function"==typeof method_exe&&(s[method_name]=method_exe,n=!0):(r[method_name]={help:method_help,options:method_options,exe:method_exe},n=!0)),n},a.set_command_option=function(t){return e.extend(!0,c,t)},a.get_command_option=function(e){var t;if("string"==typeof e)t=c.hasOwnProperty(e)?c[e]:!1;else if("object"==typeof e){t={};for(var n=e.length-1;n>=0;n--)"undefined"!=typeof c[e[n]]&&(t[e[n]]=c[e[n]])}else t=c;return t},a.tokenize=function(t,n){var o={},i=e.trim(t).split(/\s+/);if("undefined"==typeof i[0]||""===i[0])o=!1;else if("undefined"!=typeof n){var a=value=quote_type=quote_open=!1,r=last_char=before_last=!1,l=n.filter(function(e){return"number"==typeof e&&e>0&&"undefined"!=typeof i[e]?(o[e]=i[e],e):void 0});n=e(n).not(l).get();for(var s=0;s<i.length;s++)r=i[s].charAt(0),last_char=i[s].slice(-1),before_last=i[s].charAt(i[s].length-2),e.inArray(i[s],n)>=0?(a=i[s],value=!1):'"'==r&&quote_open===!1&&'"'!==last_char?(quote_type='"',quote_open=!0,value=i[s]):"'"==r&&quote_open===!1&&"'"!==last_char?(quote_type="'",quote_open=!0,value=i[s]):last_char==quote_type&&quote_open===!0&&before_last+last_char!=="\\"+quote_type?(quote_open=!1,value+=" "+i[s],value=e.trim(value.substring(1).slice(0,-1).replace(/\\(.)/gm,"$1"))):quote_open===!0?value+=" "+i[s]:"'"==r&&"'"==last_char||'"'==r&&'"'==last_char?value=e.trim(i[s].substring(1).slice(0,-1)):value=i[s],a&&quote_open===!1&&(o[a]=value)}else o[i[0]]=i;return o},n.html("");var m=null,f=null,h={};n.append('<div class="loading"><span></span></div><div class="content"><div>'+u.i18n.welcome+'</div></div><div class="prompt"><div class="input" contenteditable spellcheck="false" data-caret="'+u.caret+'" data-ps="'+u.ps+'"></div></div>');var v=n.find(".prompt .input"),y=n.find(".content"),g=n.find(".loading");n.attr("data-theme",u.theme).addClass(u.theme),u.native_css&&a.native_style(n,u.theme);var b=u.autofocus,_=u.autocomplete,x=u.history_max;u.autofocus&&v.focus(),n.bind("focus click",function(){var e="";"undefined"!=typeof window.getSelection?e=window.getSelection().toString():"undefined"!=typeof document.selection&&"Text"==document.selection.type&&(e=document.selection.createRange().text),""==e&&T()}),v.click(function(){T()}),v.bind("blur",function(){b=!1}),u.caret_blink>0&&setInterval(function(){u.caret_blink>0&&b===!0&&v.toggleClass("blink")},u.caret_blink),u.native_cmds&&a.native_commands(),a.native_responses(c),quiet=null;var w=function(t){g.addClass("working");var n;if(n="undefined"!=typeof t?t:v.text(),_=u.autocomplete,x=u.history_max,c.last=n,"string"==typeof c.next&&(n=c.next.replace(/%cmd%/i,n),c.next=null,x=0),!n||""==n)return P();if(f=n.split(/\s+/)[0],"undefined"==typeof r[f])return quiet||(c.out=f+" : "+u.i18n.error_not_found),P();if(h=a.tokenize(n,r[f].options),"function"==typeof u.before_cmd&&(h=k(u.before_cmd(h)),!h))return P();if("function"==typeof d[f]&&(h=k(d[f](h)),!h))return P();if(quiet||O(c.last),"function"==typeof r[f].exe)return k(r[f].exe(h)),P();if("string"!=typeof r[f].exe)return c.out=u.i18n.error_bad_method,P();var o={};if(!u.ajax_options.data){var i={};i[u.param]=null!==c["in"]?c["in"]:f,i[u.param+"_data"]=null!==c.data?c.data:h,o.data=i}var l=e.extend(!0,o,u.ajax_options);r[f].exe&&(l.url=r[f].exe);var s=e.ajax(l);s.done(function(e){h=k(e)}),s.fail(function(e,t,n){c.out=u.i18n.error_ajax}),s.always(function(e,t,n){return P()})},k=function(t){if("object"==typeof t)for(res in t)l.hasOwnProperty(res)&&e.extend(!0,c,l[res](t));return t},q=function(){h&&(s.hasOwnProperty(f)&&k(s[f](h)),"function"==typeof u.after_cmd&&k(u.after_cmd(h)))},P=function(){_=u.autocomplete,x=u.history_max;var e=c.ps?c.ps:u.ps,t=c.out?c.out:"",o=c["in"]?c["in"]:"",i=c.last?c.last:"",a=c.next?c.next:null;quiet?y.append('<div><div class="cmd_out">'+t+"</div></div>"):y.append('<div><div class="cmd_in"><span class="cmd_ps">'+v.attr("data-ps")+"</span>"+i+'</div><div class="cmd_out">'+t+"</div></div>"),q(),v.attr("data-caret",u.caret).attr("data-ps",e).text(o),0===u.caret_blink&&v.removeClass("blink"),v.hasClass("show-caret")&&v.removeClass("show-caret"),n.hasClass(u.theme)||n.removeClass(n.attr("data-theme")).addClass(u.theme).attr("data-theme",u.theme),a&&(_=!1,x=0),quiet=null,c={ps:null,"in":null,out:null,last:null,next:a,data:null},h=c,C()},C=function(){j(),T(),g.removeClass("working")},O=function(t){"undefined"!=typeof r[f]&&""!==t&&x>0&&(p.length>u.history_entries&&p.shift(),p.push(e.trim(t))),m=0},j=function(){n.scrollTop(n.height()+1e17)},T=function(){if(v.focus(),b=!0,"undefined"!=typeof window.getSelection&&"undefined"!=typeof document.createRange){var e=document.createRange();e.selectNodeContents(v.get(0)),e.collapse(!1);var t=window.getSelection();t.removeAllRanges(),t.addRange(e)}else if("undefined"!=typeof document.body.createTextRange){var n=document.body.createTextRange();n.moveToElementText(v.get(0)),n.collapse(!1),n.select()}},S=function(e){var t=[];if(e.match(/^[^\s]{0,}$/)){for(i in r)""==e?t.push(i):0==i.indexOf(e)&&t.push(i);t.length>1?(c.out="<ul><li>"+t.join("</li><li>")+"</li></ul>",c["in"]=e,P()):1==t.length&&v.text(t.pop()+" ")}};v.keydown(function(t){var n=t.keyCode;switch(n){case 9:t.preventDefault(),_&&(S(e.trim(v.text())),C());break;case 37:case 39:u.caret_blink>0&&(b=!1,v.addClass("blink show-caret"));break;case 38:t.preventDefault(),x>0&&(m=null===m||0==m?p.length-1:m-1,v.text(p[m]),C());break;case 40:if(t.preventDefault(),x>0){if(null===m||m==p.length-1){v.html("");break}m++,v.text(p[m]),C()}break;case 46:case 8:(1===v.text().length||window.getSelection().toString()==v.text())&&v.html("");break;case 13:t.preventDefault(),document.execCommand("insertHTML",!1,""),w();break;case 27:c={ps:null,"in":null,out:null,last:null,next:null,data:null},v.text(""),w()}})}),a}}(jQuery);